VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 1  'Persistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "CCounter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Sub OutputDebugString Lib "kernel32" Alias "OutputDebugStringA" (ByVal lpOutputString As String)

Const CCOUNTER_COUNT = "CCounter_Count"
Const DEF_CCOUNTER_COUNT = 0
Private m_nCount As Long

Private Sub Trace(sMsg As String)
    Dim sNow As String
    sNow = FormatDateTime(Now(), vbLongTime)
    OutputDebugString sNow & ":AdvOrchTxn.CCounter: " & sMsg & vbCrLf
End Sub

Function GetCount() As Long
    GetCount = m_nCount
    Trace "GetCount() = " & CStr(m_nCount)
End Function

Sub SetCount(ByVal nCount As Long)
    m_nCount = nCount
    Trace "SetCount(" & CStr(m_nCount) & ")"
End Sub

Sub IncrementCount()
    m_nCount = m_nCount + 1
    Trace "IncrementCount() = " & CStr(m_nCount)
End Sub

Private Sub Class_Initialize()
    Trace "Class_Initialize()"
    m_nCount = DEF_CCOUNTER_COUNT
End Sub

Private Sub Class_InitProperties()
    Trace "Class_InitProperties()"
End Sub

' Implementation for IPersistStreamInit
Private Sub Class_ReadProperties(PropBag As PropertyBag)
    m_nCount = PropBag.ReadProperty(CCOUNTER_COUNT, DEF_CCOUNTER_COUNT)
    Trace "Class_ReadProperties(): m_nCount = " & CStr(m_nCount)
End Sub

Private Sub Class_Terminate()
    Trace "Class_Terminate()"
End Sub

' Implementation for IPersistStreamInit
Private Sub Class_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty CCOUNTER_COUNT, m_nCount, DEF_CCOUNTER_COUNT
    Trace "Class_WriteProperties(): m_nCount = " & CStr(m_nCount)
End Sub

